---
title: WebGLRenderingContext.framebufferTexture2D()
slug: Web/API/WebGLRenderingContext/framebufferTexture2D
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.framebufferTexture2D()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> attaches a texture to a {{domxref("WebGLFramebuffer")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.framebufferTexture2D(<var>target</var>, <var>attachment</var>, <var>textarget</var>, <var>texture</var>, <var>level</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target). Possible values:
 <ul>
  <li><code>gl.FRAMEBUFFER</code>: Collection buffer data storage of color, alpha, depth and stencil buffers used to render an image.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.DRAW_FRAMEBUFFER</code>: Equivalent to <code>gl.FRAMEBUFFER</code>. Used as a destination for drawing, rendering, clearing, and writing operations.</li>
    <li><code>gl.READ_FRAMEBUFFER</code>: Used as a source for reading operations.
     <ul>
     </ul>
    </li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>attachment</dt>
 <dd>A {{domxref("GLenum")}} specifying the attachment point for the <code>texture</code>. Possible values:
 <ul>
  <li><code>gl.COLOR_ATTACHMENT0</code>: Attaches the texture to the framebuffer's color buffer.</li>
  <li><code>gl.DEPTH_ATTACHMENT</code>: Attaches the texture to the framebuffer's depth buffer.</li>
  <li><code>gl.STENCIL_ATTACHMENT</code>: Attaches the texture to the framebuffer's stencil buffer.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.DEPTH_STENCIL_ATTACHMENT</code>: depth and stencil buffer.</li>
    <li><code>gl.COLOR_ATTACHMENT1<br>
     gl.COLOR_ATTACHMENT2<br>
     gl.COLOR_ATTACHMENT3<br>
     gl.COLOR_ATTACHMENT4<br>
     gl.COLOR_ATTACHMENT5<br>
     gl.COLOR_ATTACHMENT6<br>
     gl.COLOR_ATTACHMENT7<br>
     gl.COLOR_ATTACHMENT8<br>
     gl.COLOR_ATTACHMENT9<br>
     gl.COLOR_ATTACHMENT10<br>
     gl.COLOR_ATTACHMENT11<br>
     gl.COLOR_ATTACHMENT12<br>
     gl.COLOR_ATTACHMENT13<br>
     gl.COLOR_ATTACHMENT14<br>
     gl.COLOR_ATTACHMENT15</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_draw_buffers")}} extension:
   <ul>
    <li><code>ext.COLOR_ATTACHMENT0_WEBGL</code> (same as <code>gl.COLOR_ATTACHMENT0</code>)<br>
     <code>ext.COLOR_ATTACHMENT1_WEBGL<br>
     ext.COLOR_ATTACHMENT2_WEBGL<br>
     ext.COLOR_ATTACHMENT3_WEBGL<br>
     ext.COLOR_ATTACHMENT4_WEBGL<br>
     ext.COLOR_ATTACHMENT5_WEBGL<br>
     ext.COLOR_ATTACHMENT6_WEBGL<br>
     ext.COLOR_ATTACHMENT7_WEBGL<br>
     ext.COLOR_ATTACHMENT8_WEBGL<br>
     ext.COLOR_ATTACHMENT9_WEBGL<br>
     ext.COLOR_ATTACHMENT10_WEBGL<br>
     ext.COLOR_ATTACHMENT11_WEBGL<br>
     ext.COLOR_ATTACHMENT12_WEBGL<br>
     ext.COLOR_ATTACHMENT13_WEBGL<br>
     ext.COLOR_ATTACHMENT14_WEBGL<br>
     ext.COLOR_ATTACHMENT15_WEBGL</code></li>
   </ul>
  </li>
  <li>When using the {{domxref("WEBGL_depth_texture")}} extension:
   <ul>
    <li><code>gl.DEPTH_STENCIL_ATTACHMENT</code>: Depth and stencil buffer data storage.</li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>textarget</dt>
 <dd>A {{domxref("GLenum")}} specifying the texture target. Possible values:
 <ul>
  <li><code>gl.TEXTURE_2D</code>: A 2D image.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_X</code>: Image for the positive X face of the cube.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_X</code>: Image for the negative X face of the cube.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Y</code>: Image for the positive Y face of the cube.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Y</code>: Image for the negative Y face of the cube.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_POSITIVE_Z</code>: Image for the positive Z face of the cube.</li>
  <li><code>gl.TEXTURE_CUBE_MAP_NEGATIVE_Z</code>: Image for the negative Z face of the cube.</li>
 </ul>
 </dd>
 <dt>texture</dt>
 <dd>A {{domxref("WebGLTexture")}} object whose image to attach.</dd>
 <dt>level</dt>
 <dd>A {{domxref("GLint")}} specifying the mipmap level of the texture image to be attached. Must be 0.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>A <code>gl.INVALID_ENUM</code> error is thrown if

  <ul>
   <li><code>target</code> is not <code>gl.FRAMEBUFFER</code>.</li>
   <li><code>attachment</code> is not one of the accepted attachment points.</li>
   <li><code>textarget</code> is not one of the accepted texture targets.</li>
  </ul>
 </li>
 <li>A <code>gl.INVALID_VALUE</code> error is thrown if <code>level</code> is not 0.</li>
 <li>A <code>gl.INVALID_OPERATION</code> error is thrown if <code>texture</code> isn't 0 or the name of an existing texture object.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, texture, 0);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.6", "framebufferTexture2D")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glFramebufferTexture2D.xml", "glFramebufferTexture2D")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 2 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glFramebufferTexture2D.xhtml", "glFramebufferTexture2D")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3 API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.framebufferTexture2D")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.createFramebuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.deleteFramebuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.isFramebuffer()")}}</li>
 <li>Other buffers: {{domxref("WebGLBuffer")}}, {{domxref("WebGLRenderbuffer")}}</li>
 <li>{{domxref("WEBGL_depth_texture")}}</li>
 <li>{{domxref("WEBGL_draw_buffers")}}</li>
</ul>
